<!DOCTYPE html>
<html lang="en" prefix="og: http://ogp.me/ns#">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  <meta http-equiv="Content-Language" content="en-us" />
  <meta http-equiv="imagetoolbar" content="false" />
  <meta name="MSSmartTagsPreventParsing" content="true" />
  <meta name="viewport" content="width=device-width,initial-scale=1">
  <title>Authorizing OAuth Apps | GitHub Developer Guide</title>
  <meta property="og:url" content="https://developer.github.com/apps/building-oauth-apps/authorizing-oauth-apps/" />
<meta property="og:site_name" content="GitHub Developer" />
<meta property="og:title" content="Authorizing OAuth Apps" />
<meta property="og:description" content="Get started with one of our guides, or jump straight into the API documentation." />
<meta property="og:type" content="website" />
<meta property="og:author" content="https://www.facebook.com/GitHub" />
<meta property="og:image" content="https://og.github.com/logo/github-logo@1200x1200.png" />
<meta property="og:image:width" content="1200" />
<meta property="og:image:height" content="1200" />
<meta property="og:image" content="https://og.github.com/mark/github-mark@1200x630.png" />
<meta property="og:image:width" content="1200" />
<meta property="og:image:height" content="630" />
<meta property="og:image" content="https://og.github.com/octocat/github-octocat@1200x630.png" />
<meta property="og:image:width" content="1200" />
<meta property="og:image:height" content="630" />
<meta property="twitter:card" content="summary_large_image" />
<meta property="twitter:site" content="@github" />
<meta property="twitter:site:id" content="13334762" />
<meta property="twitter:creator" content="@githubapi" />
<meta property="twitter:creator:id" content="@539153822" />
<meta property="twitter:title" content="Authorizing OAuth Apps" />
<meta property="twitter:description" content="Get started with one of our guides, or jump straight into the API documentation." />
<meta property="twitter:image:src" content="https://og.github.com/logo/github-logo@1200x1200.png" />
<meta property="twitter:image:width" content="1200" />
<meta property="twitter:image:height" content="1200" />

  
  <link rel="alternate" type="application/atom+xml" title="API Changes" href="/changes.atom" />
  
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:400,300,400italic,500">
  <link href="/assets/stylesheets/application.css" rel="stylesheet" type="text/css" />
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/2.1.4/jquery.min.js"></script>
  <script src="/assets/javascripts/application.js" type="text/javascript"></script>
  
</head>


<body class="api ">
  

<header class="site-header">
  <div id="header" class="container">
    <a class="site-header-logo mt-1" href="/"><img src="/assets/images/github-developer-logo.svg" alt="GitHub Developer"></a>
    <nav class="site-header-nav" aria-label="Main Navigation">
      <div class="dropdown" id="api-docs-dropdown">
          <div class="dropdown-button" tabIndex="0" aria-haspopup="true" aria-expanded="false"><span class="dropdown-button-link" tabIndex="-1">Docs</span> <div class="dropdown-caret"></div></div>
          <div id="js-dropdown-menu" class="dropdown-menu">
            <a class="dropdown-menu-item" href="/apps/">Apps</a>
            <a class="dropdown-menu-item" href="/actions/">GitHub Actions</a>
            <a class="dropdown-menu-item" href="/marketplace/">GitHub Marketplace</a>
            <a class="dropdown-menu-item" href="/webhooks/">Webhooks</a>
            <a class="dropdown-menu-item" href="/partnerships/">Partnerships</a>
            <a class="dropdown-menu-item" href="/v3/">REST API v3</a>
            <a class="dropdown-menu-item" href="/v4/">GraphQL API v4</a>
          </div>
      </div>
      <a class="site-header-nav-item" href="/changes/">Blog</a>
      <a class="site-header-nav-item" href="/forum/">Forum</a>
      <div class="dropdown" id="versions-dropdown">
          <div class="dropdown-button" tabIndex="0" aria-haspopup="true" aria-expanded="false"><span class="dropdown-button-link" tabIndex="-1">Versions</span> <div class="dropdown-caret"></div></div>
          <div id="js-dropdown-menu" class="dropdown-menu">
            <a class="dropdown-menu-item" data-proofer-ignore>GitHub.com</a>
            
            <a class="dropdown-menu-item" data-proofer-ignore>GitHub Enterprise Server 2.20</a>
            
            <a class="dropdown-menu-item" data-proofer-ignore>GitHub Enterprise Server 2.19</a>
            
            <a class="dropdown-menu-item" data-proofer-ignore>GitHub Enterprise Server 2.18</a>
            
            <a class="dropdown-menu-item" data-proofer-ignore>GitHub Enterprise Server 2.17</a>
            
          </div>
      </div>
      <form accept-charset="UTF-8" action="#" class="site-header-nav-item site-header-search">
        <label id="search-container" class="mb-0">
          <input type="text" id="searchfield" class="form-control" placeholder="Search…"
            autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false" />
          <div class="cancel-search"></div>
          <ul id="search-results"></ul>
        </label>
      </form>
    </nav>
  </div>
</header>


  <div class="container app-container">
    

























  

 







    <div class="sub-nav mt-5 mb-3">
      <h2><a href="/apps/">Apps</a></h2>
      <ul>
  
  
</ul>

    </div>

    <div class="nav-select nav-select-top hide-lg hide-xl">
      <select class="form-select mt-4" onchange="if (this.value) window.location.href=this.value">
  <option value="">Navigate the docs…</option>

  <optgroup label="Apps">
    <option value="/apps/">Apps</option>
  </optgroup>

  <optgroup label="About apps">
    <option value="/apps/about-apps/">About apps</option>
  </optgroup>

  <optgroup label="Differences between GitHub Apps and OAuth Apps">
    <option value="/apps/differences-between-apps/">Differences between GitHub Apps and OAuth Apps</option>
  </optgroup>

  <optgroup label="Migrating OAuth Apps to GitHub Apps">
    <option value="/apps/migrating-oauth-apps-to-github-apps/">Migrating OAuth Apps to GitHub Apps</option>
  </optgroup>
  <optgroup label="Guide: Using Content Attachments">
    <option value="/apps/using-content-attachments/">Using content attachments</option>
  </optgroup>
  <optgroup label="Quickstart guides">
    <option value="/apps/quickstart-guides/">Overview</option>
    <option value="/apps/quickstart-guides/setting-up-your-development-environment/">Setting up your development environment</option>
    <option value="/apps/quickstart-guides/using-the-github-api-in-your-app/">Using the GitHub API in your app</option>
    <option value="/apps/quickstart-guides/creating-ci-tests-with-the-checks-api/">Creating CI tests with the Checks API</option>
  </optgroup>
  <optgroup label="Building GitHub Apps">
    <option value="/apps/building-github-apps/">Overview</option>
    <option value="/apps/building-github-apps/creating-a-github-app/">Creating a GitHub App</option>
    <option value="/apps/building-github-apps/creating-github-apps-from-a-manifest/">Creating GitHub Apps from a manifest</option>
    <option value="/apps/building-github-apps/creating-github-apps-using-url-parameters/">Creating GitHub Apps using URL parameters</option>
    <option value="/apps/building-github-apps/creating-custom-badges-for-github-apps/">Creating custom badges for GitHub Apps</option>
    <option value="/apps/building-github-apps/setting-permissions-for-github-apps/">Setting Permissions for GitHub Apps</option>
    <option value="/apps/building-github-apps/authenticating-with-github-apps/">Authenticating with GitHub Apps</option>
    <option value="/apps/building-github-apps/identifying-and-authorizing-users-for-github-apps/">Identifying and authorizing users for GitHub Apps</option>
    <option value="/apps/building-github-apps/understanding-rate-limits-for-github-apps/">Understanding rate limits for GitHub Apps</option>
  </optgroup>
  <optgroup label="Managing GitHub Apps">
    <option value="/apps/managing-github-apps/">Overview</option>
    <option value="/apps/managing-github-apps/modifying-a-github-app/">Modifying a GitHub App</option>
    <option value="/apps/managing-github-apps/editing-a-github-app-s-permissions/">Editing a GitHub App's permissions</option>
    <option value="/apps/managing-github-apps/making-a-github-app-public-or-private/">Making a GitHub App public or private</option>
    <option value="/apps/managing-github-apps/transferring-ownership-of-a-github-app/">Transferring ownership of a GitHub App</option>
    <option value="/apps/managing-github-apps/deleting-a-github-app/">Deleting a GitHub App</option>
  </optgroup>
  <optgroup label="Guide: Installing GitHub Apps">
    <option value="/apps/installing-github-apps/">Installing GitHub Apps</option>
  </optgroup>

  <optgroup label="Building OAuth Apps">
    <option value="/apps/building-oauth-apps/">Overview</option>
    <option value="/apps/building-oauth-apps/creating-an-oauth-app/">Creating an OAuth App</option>
    <option value="/apps/building-oauth-apps/creating-custom-badges-for-oauth-apps/">Creating custom badges for OAuth Apps</option>
    <option value="/apps/building-oauth-apps/authorizing-oauth-apps/">Authorizing OAuth Apps</option>
    <option value="/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/">Understanding scopes for OAuth Apps</option>
  </optgroup>

  <optgroup label="Managing OAuth Apps">
    <option value="/apps/managing-oauth-apps/">Overview</option>
    <option value="/apps/managing-oauth-apps/modifying-an-oauth-app/">Modifying an OAuth App</option>
    <option value="/apps/managing-oauth-apps/transferring-ownership-of-an-oauth-app/">Transferring ownership of an OAuth App</option>
    <option value="/apps/managing-oauth-apps/troubleshooting-authorization-request-errors/">Troubleshooting authorization request errors</option>
    <option value="/apps/managing-oauth-apps/troubleshooting-oauth-app-access-token-request-errors/">Troubleshooting OAuth App access token request errors</option>
    <option value="/apps/managing-oauth-apps/deleting-an-oauth-app/">Deleting an OAuth App</option>
  </optgroup>

</select>

    </div>

    <section class="main pt-5 clearfix gut-3" role="main">
      <div class="content col-md-8">
        <h1>
<a id="authorizing-oauth-apps" class="anchor" href="#authorizing-oauth-apps" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Authorizing OAuth Apps</h1>

<div class="intro">

<p>You can enable other users to authorize your OAuth App.</p>

</div>

<ul id="markdown-toc">
<li><a href="#web-application-flow" id="markdown-toc-web-application-flow">Web application flow</a></li>
<li><a href="#non-web-application-flow" id="markdown-toc-non-web-application-flow">Non-Web application flow</a></li>
<li><a href="#redirect-urls" id="markdown-toc-redirect-urls">Redirect URLs</a></li>
<li><a href="#creating-multiple-tokens-for-oauth-apps" id="markdown-toc-creating-multiple-tokens-for-oauth-apps">Creating multiple tokens for OAuth Apps</a></li>
<li><a href="#directing-users-to-review-their-access" id="markdown-toc-directing-users-to-review-their-access">Directing users to review their access</a></li>
</ul>

<p>GitHub's OAuth implementation supports the standard <a href="https://tools.ietf.org/html/rfc6749#section-4.1">authorization code grant type</a>. You should implement the web application flow described below to obtain an authorization code and then exchange it for a token. (The <a href="https://tools.ietf.org/html/rfc6749#section-4.2">implicit grant type</a> is not supported.)</p>

<p>For troubleshooting information, see the following articles:</p>

<ul>
<li>"<a href="/apps/managing-oauth-apps/troubleshooting-authorization-request-errors">Troubleshooting authorization request errors</a>"</li>
<li>"<a href="/apps/managing-oauth-apps/troubleshooting-oauth-app-access-token-request-errors">Troubleshooting OAuth App access token request errors</a>"</li>
</ul>

<h2>
<a id="web-application-flow" class="anchor" href="#web-application-flow" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Web application flow</h2>

<div class="alert note">

<p><strong>Note:</strong> If you are building a GitHub App, you can still use the OAuth web application flow, but the setup has some important differences. See <a href="/apps/building-github-apps/identifying-and-authorizing-users-for-github-apps/">Identifying and authorizing users for GitHub Apps</a> for more information.</p>

</div>

<p>The flow to authorize users for your app is:</p>

<ol>
<li>Users are redirected to request their GitHub identity</li>
<li>Users are redirected back to your site by GitHub</li>
<li>Your app accesses the API with the user's access token</li>
</ol>

<h3>
<a id="1-request-a-users-github-identity" class="anchor" href="#1-request-a-users-github-identity" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>1. Request a user's GitHub identity</h3>

<pre><code>GET https://github.com/login/oauth/authorize
</code></pre>

<p>When your GitHub App specifies a <code>login</code> parameter, it prompts users with a specific account they can use for signing in and authorizing your app.</p>

<h4>
<a id="parameters" class="anchor" href="#parameters" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Parameters</h4>

<table>
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr>
<td><code>client_id</code></td>
<td><code>string</code></td>
<td>
<strong>Required</strong>. The client ID you received from GitHub when you <a href="https://github.com/settings/applications/new">registered</a>.</td>
</tr>
<tr>
<td><code>redirect_uri</code></td>
<td><code>string</code></td>
<td>The URL in your application where users will be sent after authorization. See details below about <a href="#redirect-urls">redirect urls</a>.</td>
</tr>
<tr>
<td><code>login</code></td>
<td><code>string</code></td>
<td>Suggests a specific account to use for signing in and authorizing the app.</td>
</tr>
<tr>
<td><code>scope</code></td>
<td><code>string</code></td>
<td>A space-delimited list of <a href="/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/">scopes</a>. If not provided, <code>scope</code> defaults to an empty list for users that have not authorized any scopes for the application. For users who have authorized scopes for the application, the user won't be shown the OAuth authorization page with the list of scopes. Instead, this step of the flow will automatically complete with the set of scopes the user has authorized for the application. For example, if a user has already performed the web flow twice and has authorized one token with <code>user</code> scope and another token with <code>repo</code> scope, a third web flow that does not provide a <code>scope</code> will receive a token with <code>user</code> and <code>repo</code> scope.</td>
</tr>
<tr>
<td><code>state</code></td>
<td><code>string</code></td>
<td>An unguessable random string. It is used to protect against cross-site request forgery attacks.</td>
</tr>
<tr>
<td><code>allow_signup</code></td>
<td><code>string</code></td>
<td>Whether or not unauthenticated users will be offered an option to sign up for GitHub during the OAuth flow. The default is <code>true</code>. Use <code>false</code> when a policy prohibits signups.</td>
</tr>
</tbody>
</table>

<h3>
<a id="2-users-are-redirected-back-to-your-site-by-github" class="anchor" href="#2-users-are-redirected-back-to-your-site-by-github" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>2. Users are redirected back to your site by GitHub</h3>

<p>If the user accepts your request, GitHub redirects back to your site with a temporary <code>code</code> in a code parameter as well as the state you provided in the previous step in a <code>state</code> parameter. The temporary code will expire after 10 minutes. If the states don't match, then a third party created the request, and you should abort the process.</p>

<p>Exchange this <code>code</code> for an access token:</p>

<pre><code>POST https://github.com/login/oauth/access_token
</code></pre>

<h4>
<a id="parameters-1" class="anchor" href="#parameters-1" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Parameters</h4>

<table>
<thead>
<tr>
<th>Name</th>
<th>Type</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr>
<td><code>client_id</code></td>
<td><code>string</code></td>
<td>
<strong>Required.</strong> The client ID you received from GitHub for your GitHub App.</td>
</tr>
<tr>
<td><code>client_secret</code></td>
<td><code>string</code></td>
<td>
<strong>Required.</strong> The client secret you received from GitHub for your GitHub App.</td>
</tr>
<tr>
<td><code>code</code></td>
<td><code>string</code></td>
<td>
<strong>Required.</strong> The code you received as a response to Step 1.</td>
</tr>
<tr>
<td><code>redirect_uri</code></td>
<td><code>string</code></td>
<td>The URL in your application where users are sent after authorization.</td>
</tr>
<tr>
<td><code>state</code></td>
<td><code>string</code></td>
<td>The unguessable random string you provided in Step 1.</td>
</tr>
</tbody>
</table>

<h4>
<a id="response" class="anchor" href="#response" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Response</h4>

<p>By default, the response takes the following form:</p>

<pre><code>access_token=e72e16c7e42f292c6912e7710c838347ae178b4a&amp;token_type=bearer
</code></pre>

<p>You can also receive the content in different formats depending on the Accept
header:</p>

<pre><code>Accept: application/json
{"access_token":"e72e16c7e42f292c6912e7710c838347ae178b4a", "scope":"repo,gist", "token_type":"bearer"}

Accept: application/xml
&lt;OAuth&gt;
  &lt;token_type&gt;bearer&lt;/token_type&gt;
  &lt;scope&gt;repo,gist&lt;/scope&gt;
  &lt;access_token&gt;e72e16c7e42f292c6912e7710c838347ae178b4a&lt;/access_token&gt;
&lt;/OAuth&gt;
</code></pre>

<h3>
<a id="3-use-the-access-token-to-access-the-api" class="anchor" href="#3-use-the-access-token-to-access-the-api" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>3. Use the access token to access the API</h3>

<p>The access token allows you to make requests to the API on a behalf of a user.</p>

<pre><code>Authorization: token OAUTH-TOKEN
GET https://api.github.com/user
</code></pre>

<p>For example, in curl you can set the Authorization header like this:</p>

<pre class="command-line">
curl -H "Authorization: token OAUTH-TOKEN" https://api.github.com/user
</pre>

<h2>
<a id="non-web-application-flow" class="anchor" href="#non-web-application-flow" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Non-Web application flow</h2>

<p>Non-web authentication is available for limited situations like testing. If you need to, you can use <a href="/v3/auth#basic-authentication">Basic Authentication</a> to create a personal access token using your <a href="https://help.github.com/articles/creating-an-access-token-for-command-line-use">Personal access tokens settings page</a>. This technique enables the user to revoke access at any time.</p>

<div class="alert note">

<p><strong>Note:</strong> When using the non-web application flow to create an OAuth2 token, make sure to understand how to <a href="/v3/auth/#working-with-two-factor-authentication">work with
two-factor authentication</a> if
you or your users have two-factor authentication enabled.</p>

</div>

<h2>
<a id="redirect-urls" class="anchor" href="#redirect-urls" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Redirect URLs</h2>

<p>The <code>redirect_uri</code> parameter is optional. If left out, GitHub will
redirect users to the callback URL configured in the OAuth Application
settings. If provided, the redirect URL's host and port must exactly
match the callback URL. The redirect URL's path must reference a
subdirectory of the callback URL.</p>

<pre><code>CALLBACK: http://example.com/path

GOOD: http://example.com/path
GOOD: http://example.com/path/subdir/other
BAD:  http://example.com/bar
BAD:  http://example.com/
BAD:  http://example.com:8080/path
BAD:  http://oauth.example.com:8080/path
BAD:  http://example.org
</code></pre>

<h3>
<a id="localhost-redirect-urls" class="anchor" href="#localhost-redirect-urls" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Localhost redirect urls</h3>

<p>The optional <code>redirect_uri</code> parameter can also be used for localhost URLs. If the application specifies a localhost URL and a port, then after authorizing the application users will be redirected to the provided URL and port. The <code>redirect_uri</code> does not need to match the port specified in the callback url for the app.</p>

<p>For the <code>http://localhost/path</code> callback URL, you can use this <code>redirect_uri</code>:</p>

<p>http://localhost:1234/path</p>

<h2>
<a id="creating-multiple-tokens-for-oauth-apps" class="anchor" href="#creating-multiple-tokens-for-oauth-apps" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Creating multiple tokens for OAuth Apps</h2>

<p>You can create multiple tokens for a user/application/scope combination to create tokens for specific use cases.</p>

<p>This is useful if your OAuth App supports one workflow that uses GitHub for sign-in and only requires basic user information. Another workflow may require access to a user's private repositories. Using multiple tokens, your OAuth App can perform the web flow for each use case, requesting only the scopes needed. If a user only uses your application to sign in, they are never required to grant your OAuth App access to their private repositories.</p>

<p>There is a limit to the number of tokens that are issued per user/application/scope combination. If your application requests enough tokens to go over one of the limits, older tokens <em>with the same scope being requested</em> will stop working.</p>

<div class="alert warning">

<p><strong>Warning</strong>: Revoking all permission from an OAuth App deletes any SSH keys the application generated on behalf of the user, including <a href="/v3/guides/managing-deploy-keys/#deploy-keys">deploy keys</a>.</p>

</div>

<h2>
<a id="directing-users-to-review-their-access" class="anchor" href="#directing-users-to-review-their-access" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Directing users to review their access</h2>

<p>You can link to authorization information for an OAuth App so that users can review and revoke their application authorizations.</p>

<p>To build this link, you'll need your OAuth Apps <code>client_id</code> that you received from GitHub when you registered the application.</p>

<pre><code>https://github.com/settings/connections/applications/:client_id
</code></pre>

<div class="alert tip">

<p><strong>Tip:</strong> To learn more about the resources that your OAuth App can access for a user, see "<a href="/v3/guides/discovering-resources-for-a-user/">Discovering resources for a user</a>."</p>

</div>
      </div>

      <div class="nav-select nav-select-bottom hide-lg hide-xl">
        <select class="form-select mt-4" onchange="if (this.value) window.location.href=this.value">
  <option value="">Navigate the docs…</option>

  <optgroup label="Apps">
    <option value="/apps/">Apps</option>
  </optgroup>

  <optgroup label="About apps">
    <option value="/apps/about-apps/">About apps</option>
  </optgroup>

  <optgroup label="Differences between GitHub Apps and OAuth Apps">
    <option value="/apps/differences-between-apps/">Differences between GitHub Apps and OAuth Apps</option>
  </optgroup>

  <optgroup label="Migrating OAuth Apps to GitHub Apps">
    <option value="/apps/migrating-oauth-apps-to-github-apps/">Migrating OAuth Apps to GitHub Apps</option>
  </optgroup>
  <optgroup label="Guide: Using Content Attachments">
    <option value="/apps/using-content-attachments/">Using content attachments</option>
  </optgroup>
  <optgroup label="Quickstart guides">
    <option value="/apps/quickstart-guides/">Overview</option>
    <option value="/apps/quickstart-guides/setting-up-your-development-environment/">Setting up your development environment</option>
    <option value="/apps/quickstart-guides/using-the-github-api-in-your-app/">Using the GitHub API in your app</option>
    <option value="/apps/quickstart-guides/creating-ci-tests-with-the-checks-api/">Creating CI tests with the Checks API</option>
  </optgroup>
  <optgroup label="Building GitHub Apps">
    <option value="/apps/building-github-apps/">Overview</option>
    <option value="/apps/building-github-apps/creating-a-github-app/">Creating a GitHub App</option>
    <option value="/apps/building-github-apps/creating-github-apps-from-a-manifest/">Creating GitHub Apps from a manifest</option>
    <option value="/apps/building-github-apps/creating-github-apps-using-url-parameters/">Creating GitHub Apps using URL parameters</option>
    <option value="/apps/building-github-apps/creating-custom-badges-for-github-apps/">Creating custom badges for GitHub Apps</option>
    <option value="/apps/building-github-apps/setting-permissions-for-github-apps/">Setting Permissions for GitHub Apps</option>
    <option value="/apps/building-github-apps/authenticating-with-github-apps/">Authenticating with GitHub Apps</option>
    <option value="/apps/building-github-apps/identifying-and-authorizing-users-for-github-apps/">Identifying and authorizing users for GitHub Apps</option>
    <option value="/apps/building-github-apps/understanding-rate-limits-for-github-apps/">Understanding rate limits for GitHub Apps</option>
  </optgroup>
  <optgroup label="Managing GitHub Apps">
    <option value="/apps/managing-github-apps/">Overview</option>
    <option value="/apps/managing-github-apps/modifying-a-github-app/">Modifying a GitHub App</option>
    <option value="/apps/managing-github-apps/editing-a-github-app-s-permissions/">Editing a GitHub App's permissions</option>
    <option value="/apps/managing-github-apps/making-a-github-app-public-or-private/">Making a GitHub App public or private</option>
    <option value="/apps/managing-github-apps/transferring-ownership-of-a-github-app/">Transferring ownership of a GitHub App</option>
    <option value="/apps/managing-github-apps/deleting-a-github-app/">Deleting a GitHub App</option>
  </optgroup>
  <optgroup label="Guide: Installing GitHub Apps">
    <option value="/apps/installing-github-apps/">Installing GitHub Apps</option>
  </optgroup>

  <optgroup label="Building OAuth Apps">
    <option value="/apps/building-oauth-apps/">Overview</option>
    <option value="/apps/building-oauth-apps/creating-an-oauth-app/">Creating an OAuth App</option>
    <option value="/apps/building-oauth-apps/creating-custom-badges-for-oauth-apps/">Creating custom badges for OAuth Apps</option>
    <option value="/apps/building-oauth-apps/authorizing-oauth-apps/">Authorizing OAuth Apps</option>
    <option value="/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/">Understanding scopes for OAuth Apps</option>
  </optgroup>

  <optgroup label="Managing OAuth Apps">
    <option value="/apps/managing-oauth-apps/">Overview</option>
    <option value="/apps/managing-oauth-apps/modifying-an-oauth-app/">Modifying an OAuth App</option>
    <option value="/apps/managing-oauth-apps/transferring-ownership-of-an-oauth-app/">Transferring ownership of an OAuth App</option>
    <option value="/apps/managing-oauth-apps/troubleshooting-authorization-request-errors/">Troubleshooting authorization request errors</option>
    <option value="/apps/managing-oauth-apps/troubleshooting-oauth-app-access-token-request-errors/">Troubleshooting OAuth App access token request errors</option>
    <option value="/apps/managing-oauth-apps/deleting-an-oauth-app/">Deleting an OAuth App</option>
  </optgroup>

</select>

      </div>

      <div id="js-sidebar" class="sidebar-shell col-md-4 hide-sm hide-md d-md-block d-lg-block d-xl-block">
        <div class="js-toggle-list sidebar-module sidebar-menu expandable">
          <ul>
            <li class="js-topic"><h3 class="standalone"><a href="/apps/about-apps/">About Apps</a></h3></li>
            <li class="js-topic"><h3 class="standalone"><a href="/apps/differences-between-apps/">Differences between GitHub Apps and OAuth Apps</a></h3></li>
            <li class="js-topic"><h3 class="standalone"><a href="/apps/migrating-oauth-apps-to-github-apps/">Migrating OAuth Apps to GitHub Apps</a></h3></li>
            <li class="js-topic"><h3 class="standalone"><a href="/apps/using-content-attachments/">Using content attachments</a></h3></li>
            <li class="js-topic">
              <h3><a href="#" class="js-expand-btn collapsed arrow-btn" data-proofer-ignore></a><a href="/apps/quickstart-guides/">Quickstart guides</a></h3>
              <ul class="js-guides">
                <li><a href="/apps/quickstart-guides/setting-up-your-development-environment/">Setting up your development environment</a></li>
                <li><a href="/apps/quickstart-guides/using-the-github-api-in-your-app/">Using the GitHub API in your app</a></li>
                <li><a href="/apps/quickstart-guides/creating-ci-tests-with-the-checks-api/">Creating CI tests with the Checks API</a></li>
              </ul>
            </li>
            <li class="js-topic">
              <h3><a href="#" class="js-expand-btn collapsed arrow-btn" data-proofer-ignore></a><a href="/apps/building-github-apps/">Building GitHub Apps</a></h3>
              <ul class="js-guides">
                <li><a href="/apps/building-github-apps/creating-a-github-app/">Creating a GitHub App</a></li>
                <li><a href="/apps/building-github-apps/creating-github-apps-from-a-manifest/">Creating GitHub Apps from a manifest</a></li>
                <li><a href="/apps/building-github-apps/creating-github-apps-using-url-parameters/">Creating GitHub Apps using URL parameters</a></li>
                <li><a href="/apps/building-github-apps/creating-custom-badges-for-github-apps/">Creating custom badges for GitHub Apps</a></li>
                <li><a href="/apps/building-github-apps/setting-permissions-for-github-apps/">Setting permissions for GitHub Apps</a></li>
                <li><a href="/apps/building-github-apps/authenticating-with-github-apps/">Authenticating with GitHub Apps</a></li>
                <li><a href="/apps/building-github-apps/identifying-and-authorizing-users-for-github-apps/">Identifying and authorizing users for GitHub Apps</a></li>
                <li><a href="/apps/building-github-apps/understanding-rate-limits-for-github-apps/">Understanding rate limits for GitHub Apps</a></li>
              </ul>
            </li>
            <li class="js-topic">
              <h3><a href="#" class="js-expand-btn collapsed arrow-btn" data-proofer-ignore></a><a href="/apps/managing-github-apps/">Managing GitHub Apps</a></h3>
              <ul class="js-guides">
                <li><a href="/apps/managing-github-apps/modifying-a-github-app/">Modifying a GitHub App</a></li>
                <li><a href="/apps/managing-github-apps/editing-a-github-app-s-permissions/">Editing a GitHub App's permissions</a></li>
                <li><a href="/apps/managing-github-apps/making-a-github-app-public-or-private/">Making a GitHub App public or private</a></li>
                <li><a href="/apps/managing-github-apps/transferring-ownership-of-a-github-app/">Transferring ownership of a GitHub App</a></li>
                <li><a href="/apps/managing-github-apps/deleting-a-github-app/">Deleting a GitHub App</a></li>
              </ul>
            </li>
            <li class="js-topic"><h3 class="standalone"><a href="/apps/installing-github-apps/">Installing GitHub Apps</a></h3></li>
            <li class="js-topic">
              <h3><a href="#" class="js-expand-btn collapsed arrow-btn" data-proofer-ignore></a><a href="/apps/building-oauth-apps/">Building OAuth Apps</a></h3>
              <ul class="js-guides">
                <li><a href="/apps/building-oauth-apps/creating-an-oauth-app/">Creating an OAuth App</a></li>
                <li><a href="/apps/building-oauth-apps/creating-custom-badges-for-oauth-apps/">Creating custom badges for OAuth Apps</a></li>
                <li><a href="/apps/building-oauth-apps/authorizing-oauth-apps/">Authorizing OAuth Apps</a></li>
                <li><a href="/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/">Understanding scopes for OAuth Apps</a></li>
              </ul>
            </li>
            <li class="js-topic">
              <h3><a href="#" class="js-expand-btn collapsed arrow-btn" data-proofer-ignore></a><a href="/apps/managing-oauth-apps/">Managing OAuth Apps</a></h3>
              <ul class="js-guides">
                <li><a href="/apps/managing-oauth-apps/modifying-an-oauth-app/">Modifying an OAuth App</a></li>
                <li><a href="/apps/managing-oauth-apps/transferring-ownership-of-an-oauth-app/">Transferring ownership of an OAuth App</a></li>
                <li><a href="/apps/managing-oauth-apps/troubleshooting-authorization-request-errors/">Troubleshooting authorization request errors</a></li>
                <li><a href="/apps/managing-oauth-apps/troubleshooting-oauth-app-access-token-request-errors/">Troubleshooting OAuth App access token request errors</a></li>
                <li><a href="/apps/managing-oauth-apps/deleting-an-oauth-app/">Deleting an OAuth App</a></li>
              </ul>
            </li>
          </ul>
        </div>
        <div class="sidebar-module api-status py-4 text-center"><a href="https://status.github.com" class="unknown">API Status</a></div>

      </div><!-- sidebar-shell -->
    </section>
  </div>

  <footer class="footer text-muted">
  <div class="container">
    <span class="footer-legal">&copy; 2020 GitHub Inc. All rights reserved.</span>
    <span class="mega-octicon octicon-mark-github footer-mark"></span>
    <nav class="footer-nav">
      <a class="footer-nav-item" href="https://help.github.com/articles/github-terms-of-service">Terms of service</a>
      <a class="footer-nav-item" href="https://github.com/site/privacy">Privacy</a>
      <a class="footer-nav-item" href="https://github.com/security">Security</a>
      <a class="footer-nav-item" href="https://github.com/support">Support</a>
    </nav>
  </div>
</footer>

<script>
  (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
  (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
  m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
  })(window,document,'script','//www.google-analytics.com/analytics.js','ga');

  ga('create', 'UA-3769691-37', 'github.com');
  ga('send', 'pageview');
</script>

</body>
</html>
